Package org.apache.tools.tar

# Class TarEntry

java.lang.Object
org.apache.tools.tar.TarEntry

All Implemented Interfaces:
  `TarConstants`

    public class TarEntry
    extends java.lang.Object
    implements TarConstants

This class represents an entry in a Tar archive. It consists of the entry's header, as well as the entry's File. Entries can be instantiated in one of three ways, depending on how they are to be used.

TarEntries that are created from the header bytes read from an archive are instantiated with the TarEntry(byte[]) constructor. These entries will be used when extracting from or listing the contents of an archive. These entries have their header filled in using the header bytes. They also set the File to null, since they reference an archive entry not a file.

TarEntries that are created from Files that are to be written into an archive are instantiated with the TarEntry(File) constructor. These entries have their header filled in using the File's information. They also keep a reference to the File for convenience when writing entries.

Finally, TarEntries can be constructed from nothing but a name. This allows the programmer to construct the entry by hand, for instance when only an InputStream is available for writing to the archive, and the header information is constructed from other information. In this case the header fields are set to defaults and the File is set to null.

The C structure for a Tar Entry's header is:

     struct header {
     char name[NAMSIZ];
     char mode[8];
     char uid[8];
     char gid[8];
     char size[12];
     char mtime[12];
     char chksum[8];
     char linkflag;
     char linkname[NAMSIZ];
     char magic[8];
     char uname[TUNMLEN];
     char gname[TGNMLEN];
     char devmajor[8];
     char devminor[8];
     } header;
     All unused bytes are set to null.
     New-style GNU tar files are slightly different from the above.
     For values of size larger than 077777777777L (11 7s)
     or uid and gid larger than 07777777L (7 7s)
     the sign bit of the first byte is set, and the rest of the
     field is the binary representation of the number.
     See TarUtils.parseOctalOrBinary.

The C structure for a old GNU Tar Entry's header is:

     struct oldgnu_header {
     char unused_pad1[345]; // TarConstants.PAD1LEN_GNU       - offset 0
     char atime[12];        // TarConstants.ATIMELEN_GNU      - offset 345
     char ctime[12];        // TarConstants.CTIMELEN_GNU      - offset 357
     char offset[12];       // TarConstants.OFFSETLEN_GNU     - offset 369
     char longnames[4];     // TarConstants.LONGNAMESLEN_GNU  - offset 381
     char unused_pad2;      // TarConstants.PAD2LEN_GNU       - offset 385
     struct sparse sp[4];   // TarConstants.SPARSELEN_GNU     - offset 386
     char isextended;       // TarConstants.ISEXTENDEDLEN_GNU - offset 482
     char realsize[12];     // TarConstants.REALSIZELEN_GNU   - offset 483
     char unused_pad[17];   // TarConstants.PAD3LEN_GNU       - offset 495
     };

Whereas, "struct sparse" is:

     struct sparse {
     char offset[12];   // offset 0
     char numbytes[12]; // offset 12
     };

- ## Field Summary

  Fields
  Modifier and Type | Field | Description
  --- | --- | ---
  `static int` | `DEFAULT_DIR_MODE` | Default permissions bits for directories
  `static int` | `DEFAULT_FILE_MODE` | Default permissions bits for files
  `static int` | `MAX_NAMELEN` | Maximum length of a user's name in the tar file
  `static int` | `MILLIS_PER_SECOND` | Convert millis to seconds

  ### Fields inherited from interface org.apache.tools.tar.TarConstants

  `ATIMELEN_GNU, CHKSUMLEN, CTIMELEN_GNU, DEVLEN, FORMAT_OLDGNU, FORMAT_POSIX, GIDLEN, GNAMELEN, GNU_LONGLINK, GNU_TMAGIC, ISEXTENDEDLEN_GNU, ISEXTENDEDLEN_GNU_SPARSE, LF_BLK, LF_CHR, LF_CONTIG, LF_DIR, LF_FIFO, LF_GNUTYPE_LONGLINK, LF_GNUTYPE_LONGNAME, LF_GNUTYPE_SPARSE, LF_LINK, LF_NORMAL, LF_OLDNORM, LF_PAX_EXTENDED_HEADER_LC, LF_PAX_EXTENDED_HEADER_UC, LF_PAX_GLOBAL_EXTENDED_HEADER, LF_SYMLINK, LONGNAMESLEN_GNU, MAGIC_OFFSET, MAGIC_POSIX, MAGICLEN, MAXID, MAXSIZE, MODELEN, MODTIMELEN, NAMELEN, OFFSETLEN_GNU, PAD2LEN_GNU, PREFIXLEN, PURE_MAGICLEN, REALSIZELEN_GNU, SIZELEN, SPARSELEN_GNU, SPARSELEN_GNU_SPARSE, TMAGIC, UIDLEN, UNAMELEN, VERSION_GNU_SPACE, VERSION_GNU_ZERO, VERSION_OFFSET, VERSION_POSIX, VERSIONLEN`

- ## Constructor Summary

  Constructors
  Constructor | Description
  --- | ---
  `TarEntry​(byte[] headerBuf)` | Construct an entry from an archive's header bytes.
  `TarEntry​(byte[] headerBuf, ZipEncoding encoding)` | Construct an entry from an archive's header bytes.
  `TarEntry​(java.io.File file)` | Construct an entry for a file.
  `TarEntry​(java.io.File file, java.lang.String fileName)` | Construct an entry for a file.
  `TarEntry​(java.lang.String name)` | Construct an entry with only a name.
  `TarEntry​(java.lang.String name, boolean preserveLeadingSlashes)` | Construct an entry with only a name.
  `TarEntry​(java.lang.String name, byte linkFlag)` | Construct an entry with a name and a link flag.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `boolean` | `equals​(java.lang.Object it)` | Determine if the two entries are equal.
  `boolean` | `equals​(TarEntry it)` | Determine if the two entries are equal.
  `int` | `getDevMajor()` | Get this entry's major device number.
  `int` | `getDevMinor()` | Get this entry's minor device number.
  `TarEntry[]` | `getDirectoryEntries()` | If this entry represents a file, and the file is a directory, return an array of TarEntries for this entry's children.
  `java.io.File` | `getFile()` | Get this entry's file.
  `int` | `getGroupId()` | Deprecated. use #getLongGroupId instead as group ids can be bigger than `Integer.MAX_VALUE`
  `java.lang.String` | `getGroupName()` | Get this entry's group name.
  `java.lang.String` | `getLinkName()` | Get this entry's link name.
  `long` | `getLongGroupId()` | Get this entry's group id.
  `long` | `getLongUserId()` | Get this entry's user id.
  `int` | `getMode()` | Get this entry's mode.
  `java.util.Date` | `getModTime()` | Set this entry's modification time.
  `java.lang.String` | `getName()` | Get this entry's name.
  `long` | `getRealSize()` | Get this entry's real file size in case of a sparse file.
  `long` | `getSize()` | Get this entry's file size.
  `int` | `getUserId()` | Deprecated. use #getLongUserId instead as user ids can be bigger than `Integer.MAX_VALUE`
  `java.lang.String` | `getUserName()` | Get this entry's user name.
  `int` | `hashCode()` | Hashcodes are based on entry names.
  `boolean` | `isBlockDevice()` |
  `boolean` | `isCharacterDevice()` | Check if this is a character device entry.
  `boolean` | `isDescendent​(TarEntry desc)` | Determine if the given entry is a descendant of this entry.
  `boolean` | `isDirectory()` | Return whether or not this entry represents a directory.
  `boolean` | `isExtended()` | Indicates in case of a sparse file if an extension sparse header follows.
  `boolean` | `isFIFO()` |
  `boolean` | `isFile()` | Check if this is a "normal file".
  `boolean` | `isGlobalPaxHeader()` | Check if this is a Pax header.
  `boolean` | `isGNULongLinkEntry()` | Indicate if this entry is a GNU long linkname block
  `boolean` | `isGNULongNameEntry()` | Indicate if this entry is a GNU long name block
  `boolean` | `isGNUSparse()` | Indicate if this entry is a GNU sparse block.
  `boolean` | `isLink()` | Check if this is a link entry.
  `boolean` | `isPaxHeader()` | Check if this is a Pax header.
  `boolean` | `isSymbolicLink()` | Check if this is a symbolic link entry.
  `void` | `parseTarHeader​(byte[] header)` | Parse an entry's header information from a header buffer.
  `void` | `parseTarHeader​(byte[] header, ZipEncoding encoding)` | Parse an entry's header information from a header buffer.
  `void` | `setDevMajor​(int devNo)` | Set this entry's major device number.
  `void` | `setDevMinor​(int devNo)` | Set this entry's minor device number.
  `void` | `setGroupId​(int groupId)` | Set this entry's group id.
  `void` | `setGroupId​(long groupId)` | Set this entry's group id.
  `void` | `setGroupName​(java.lang.String groupName)` | Set this entry's group name.
  `void` | `setIds​(int userId, int groupId)` | Convenience method to set this entry's group and user ids.
  `void` | `setLinkName​(java.lang.String link)` | Set this entry's link name.
  `void` | `setMode​(int mode)` | Set the mode for this entry
  `void` | `setModTime​(long time)` | Set this entry's modification time.
  `void` | `setModTime​(java.util.Date time)` | Set this entry's modification time.
  `void` | `setName​(java.lang.String name)` | Set this entry's name.
  `void` | `setNames​(java.lang.String userName, java.lang.String groupName)` | Convenience method to set this entry's group and user names.
  `void` | `setSize​(long size)` | Set this entry's file size.
  `void` | `setUserId​(int userId)` | Set this entry's user id.
  `void` | `setUserId​(long userId)` | Set this entry's user id.
  `void` | `setUserName​(java.lang.String userName)` | Set this entry's user name.
  `void` | `writeEntryHeader​(byte[] outbuf)` | Write an entry's header information to a header buffer.
  `void` | `writeEntryHeader​(byte[] outbuf, ZipEncoding encoding, boolean starMode)` | Write an entry's header information to a header buffer.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### MAX_NAMELEN

    public static final int MAX_NAMELEN
    Maximum length of a user's name in the tar file
    See Also:
      Constant Field Values

  - ### DEFAULT_DIR_MODE

    public static final int DEFAULT_DIR_MODE
    Default permissions bits for directories
    See Also:
      Constant Field Values

  - ### DEFAULT_FILE_MODE

    public static final int DEFAULT_FILE_MODE
    Default permissions bits for files
    See Also:
      Constant Field Values

  - ### MILLIS_PER_SECOND

    public static final int MILLIS_PER_SECOND
    Convert millis to seconds
    See Also:
      Constant Field Values

- ## Constructor Details

  - ### TarEntry

    public TarEntry​(java.lang.String name)
    Construct an entry with only a name. This allows the programmer to construct the entry's header "by hand". File is set to null.
    Parameters:
      `name` - the entry name

  - ### TarEntry

    public TarEntry​(java.lang.String name, boolean preserveLeadingSlashes)
    Construct an entry with only a name. This allows the programmer to construct the entry's header "by hand". File is set to null.
    Parameters:
      `name` - the entry name
      `preserveLeadingSlashes` - whether to allow leading slashes in the name.

  - ### TarEntry

    public TarEntry​(java.lang.String name, byte linkFlag)
    Construct an entry with a name and a link flag.
    Parameters:
      `name` - the entry name
      `linkFlag` - the entry link flag.

  - ### TarEntry

    public TarEntry​(java.io.File file)
    Construct an entry for a file. File is set to file, and the header is constructed from information from the file. The name is set from the normalized file path.
    Parameters:
      `file` - The file that the entry represents.

  - ### TarEntry

    public TarEntry​(java.io.File file, java.lang.String fileName)
    Construct an entry for a file. File is set to file, and the header is constructed from information from the file.
    Parameters:
      `file` - The file that the entry represents.
      `fileName` - the name to be used for the entry.

  - ### TarEntry

    public TarEntry​(byte[] headerBuf)
    Construct an entry from an archive's header bytes. File is set to null.
    Parameters:
      `headerBuf` - The header bytes from a tar archive entry.
    Throws:
      `java.lang.IllegalArgumentException` - if any of the numeric fields have an invalid format

  - ### TarEntry

    public TarEntry​(byte[] headerBuf, ZipEncoding encoding) throws java.io.IOException
    Construct an entry from an archive's header bytes. File is set to null.
    Parameters:
      `headerBuf` - The header bytes from a tar archive entry.
      `encoding` - encoding to use for file names
    Throws:
      `java.lang.IllegalArgumentException` - if any of the numeric fields have an invalid format
      `java.io.IOException` - if an error occurs during reading the archive

- ## Method Details

  - ### equals

    public boolean equals​(TarEntry it)
    Determine if the two entries are equal. Equality is determined by the header names being equal.
    Parameters:
      `it` - Entry to be checked for equality.
    Returns:
      True if the entries are equal.

  - ### equals

    public boolean equals​(java.lang.Object it)
    Determine if the two entries are equal. Equality is determined by the header names being equal.
    Overrides:
      `equals` in class `java.lang.Object`
    Parameters:
      `it` - Entry to be checked for equality.
    Returns:
      True if the entries are equal.

  - ### hashCode

    public int hashCode()
    Hashcodes are based on entry names.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      the entry hashcode

  - ### isDescendent

    public boolean isDescendent​(TarEntry desc)
    Determine if the given entry is a descendant of this entry. Descendancy is determined by the name of the descendant starting with this entry's name.
    Parameters:
      `desc` - Entry to be checked as a descendant of this.
    Returns:
      True if entry is a descendant of this.

  - ### getName

    public java.lang.String getName()
    Get this entry's name.
    Returns:
      This entry's name.

  - ### setName

    public void setName​(java.lang.String name)
    Set this entry's name.
    Parameters:
      `name` - This entry's new name.

  - ### setMode

    public void setMode​(int mode)
    Set the mode for this entry
    Parameters:
      `mode` - the mode for this entry

  - ### getLinkName

    public java.lang.String getLinkName()
    Get this entry's link name.
    Returns:
      This entry's link name.

  - ### setLinkName

    public void setLinkName​(java.lang.String link)
    Set this entry's link name.
    Parameters:
      `link` - the link name to use.

  - ### getUserId

    @Deprecated public int getUserId()
    Deprecated.
    use #getLongUserId instead as user ids can be bigger than `Integer.MAX_VALUE`
    Get this entry's user id.
    Returns:
      This entry's user id.

  - ### setUserId

    public void setUserId​(int userId)
    Set this entry's user id.
    Parameters:
      `userId` - This entry's new user id.

  - ### getLongUserId

    public long getLongUserId()
    Get this entry's user id.
    Returns:
      This entry's user id.
    Since:
      1.9.5

  - ### setUserId

    public void setUserId​(long userId)
    Set this entry's user id.
    Parameters:
      `userId` - This entry's new user id.
    Since:
      1.9.5

  - ### getGroupId

    @Deprecated public int getGroupId()
    Deprecated.
    use #getLongGroupId instead as group ids can be bigger than `Integer.MAX_VALUE`
    Get this entry's group id.
    Returns:
      This entry's group id.

  - ### setGroupId

    public void setGroupId​(int groupId)
    Set this entry's group id.
    Parameters:
      `groupId` - This entry's new group id.

  - ### getLongGroupId

    public long getLongGroupId()
    Get this entry's group id.
    Returns:
      This entry's group id.
    Since:
      1.9.5

  - ### setGroupId

    public void setGroupId​(long groupId)
    Set this entry's group id.
    Parameters:
      `groupId` - This entry's new group id.
    Since:
      1.9.5

  - ### getUserName

    public java.lang.String getUserName()
    Get this entry's user name.
    Returns:
      This entry's user name.

  - ### setUserName

    public void setUserName​(java.lang.String userName)
    Set this entry's user name.
    Parameters:
      `userName` - This entry's new user name.

  - ### getGroupName

    public java.lang.String getGroupName()
    Get this entry's group name.
    Returns:
      This entry's group name.

  - ### setGroupName

    public void setGroupName​(java.lang.String groupName)
    Set this entry's group name.
    Parameters:
      `groupName` - This entry's new group name.

  - ### setIds

    public void setIds​(int userId, int groupId)
    Convenience method to set this entry's group and user ids.
    Parameters:
      `userId` - This entry's new user id.
      `groupId` - This entry's new group id.

  - ### setNames

    public void setNames​(java.lang.String userName, java.lang.String groupName)
    Convenience method to set this entry's group and user names.
    Parameters:
      `userName` - This entry's new user name.
      `groupName` - This entry's new group name.

  - ### setModTime

    public void setModTime​(long time)
    Set this entry's modification time. The parameter passed to this method is in "Java time".
    Parameters:
      `time` - This entry's new modification time.

  - ### setModTime

    public void setModTime​(java.util.Date time)
    Set this entry's modification time.
    Parameters:
      `time` - This entry's new modification time.

  - ### getModTime

    public java.util.Date getModTime()
    Set this entry's modification time.
    Returns:
      time This entry's new modification time.

  - ### getFile

    public java.io.File getFile()
    Get this entry's file.
    Returns:
      This entry's file.

  - ### getMode

    public int getMode()
    Get this entry's mode.
    Returns:
      This entry's mode.

  - ### getSize

    public long getSize()
    Get this entry's file size.
    Returns:
      This entry's file size.

  - ### setSize

    public void setSize​(long size)
    Set this entry's file size.
    Parameters:
      `size` - This entry's new file size.
    Throws:
      `java.lang.IllegalArgumentException` - if the size is < 0.

  - ### getDevMajor

    public int getDevMajor()
    Get this entry's major device number.
    Returns:
      This entry's major device number.

  - ### setDevMajor

    public void setDevMajor​(int devNo)
    Set this entry's major device number.
    Parameters:
      `devNo` - This entry's major device number.
    Throws:
      `java.lang.IllegalArgumentException` - if the devNo is < 0.

  - ### getDevMinor

    public int getDevMinor()
    Get this entry's minor device number.
    Returns:
      This entry's minor device number.

  - ### setDevMinor

    public void setDevMinor​(int devNo)
    Set this entry's minor device number.
    Parameters:
      `devNo` - This entry's minor device number.
    Throws:
      `java.lang.IllegalArgumentException` - if the devNo is < 0.

  - ### isExtended

    public boolean isExtended()
    Indicates in case of a sparse file if an extension sparse header follows.
    Returns:
      true if an extension sparse header follows.

  - ### getRealSize

    public long getRealSize()
    Get this entry's real file size in case of a sparse file.
    Returns:
      This entry's real file size.

  - ### isGNUSparse

    public boolean isGNUSparse()
    Indicate if this entry is a GNU sparse block.
    Returns:
      true if this is a sparse extension provided by GNU tar

  - ### isGNULongLinkEntry

    public boolean isGNULongLinkEntry()
    Indicate if this entry is a GNU long linkname block
    Returns:
      true if this is a long name extension provided by GNU tar

  - ### isGNULongNameEntry

    public boolean isGNULongNameEntry()
    Indicate if this entry is a GNU long name block
    Returns:
      true if this is a long name extension provided by GNU tar

  - ### isPaxHeader

    public boolean isPaxHeader()
    Check if this is a Pax header.
    Returns:
      `true` if this is a Pax header.

  - ### isGlobalPaxHeader

    public boolean isGlobalPaxHeader()
    Check if this is a Pax header.
    Returns:
      `true` if this is a Pax header.

  - ### isDirectory

    public boolean isDirectory()
    Return whether or not this entry represents a directory.
    Returns:
      True if this entry is a directory.

  - ### isFile

    public boolean isFile()
    Check if this is a "normal file".
    Returns:
      true if it is a 'normal' file

  - ### isSymbolicLink

    public boolean isSymbolicLink()
    Check if this is a symbolic link entry.
    Returns:
      true if it is a symlink

  - ### isLink

    public boolean isLink()
    Check if this is a link entry.
    Returns:
      true if it is a link

  - ### isCharacterDevice

    public boolean isCharacterDevice()
    Check if this is a character device entry.
    Returns:
      true if it is a character device entry

  - ### isBlockDevice

    public boolean isBlockDevice()
    Returns:
      true if this is a block device entry.

  - ### isFIFO

    public boolean isFIFO()
    Returns:
      true if this is a FIFO (pipe) entry.

  - ### getDirectoryEntries

    public TarEntry[] getDirectoryEntries()
    If this entry represents a file, and the file is a directory, return an array of TarEntries for this entry's children.
    Returns:
      An array of TarEntry's for this entry's children.

  - ### writeEntryHeader

    public void writeEntryHeader​(byte[] outbuf)
    Write an entry's header information to a header buffer.

    This method does not use the star/GNU tar/BSD tar extensions.

    Parameters:
      `outbuf` - The tar entry header buffer to fill in.

  - ### writeEntryHeader

    public void writeEntryHeader​(byte[] outbuf, ZipEncoding encoding, boolean starMode) throws java.io.IOException
    Write an entry's header information to a header buffer.
    Parameters:
      `outbuf` - The tar entry header buffer to fill in.
      `encoding` - encoding to use when writing the file name.
      `starMode` - whether to use the star/GNU tar/BSD tar extension for numeric fields if their value doesn't fit in the maximum size of standard tar archives
    Throws:
      `java.io.IOException` - if an error occurs while writing the archive

  - ### parseTarHeader

    public void parseTarHeader​(byte[] header)
    Parse an entry's header information from a header buffer.
    Parameters:
      `header` - The tar entry header buffer to get information from.
    Throws:
      `java.lang.IllegalArgumentException` - if any of the numeric fields have an invalid format

  - ### parseTarHeader

    public void parseTarHeader​(byte[] header, ZipEncoding encoding) throws java.io.IOException
    Parse an entry's header information from a header buffer.
    Parameters:
      `header` - The tar entry header buffer to get information from.
      `encoding` - encoding to use for file names
    Throws:
      `java.lang.IllegalArgumentException` - if any of the numeric fields have an invalid format
      `java.io.IOException` - if an error occurs while reading the archive